#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "Fish_SeniorItemExchangeCFG.h"
std::auto_ptr<Fish_SeniorItemExchangeCFG> Fish_SeniorItemExchangeCFG::msSingleton(nullptr);

int Fish_SeniorItemExchangeCFG::GetCount()
{
	return (int)mMapData.size();
}

const Fish_SeniorItemExchangeCFGData* Fish_SeniorItemExchangeCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, Fish_SeniorItemExchangeCFGData>& Fish_SeniorItemExchangeCFG::GetMapData()
{
	return mMapData;
}

void Fish_SeniorItemExchangeCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/Fish_SeniorItemExchangeCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Fish_SeniorItemExchangeCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mType = element->IntAttribute("Type");
		{
			const char* ItemId = element->Attribute("ItemId");
			std::vector<std::string> vecItemId;
			boost::split(vecItemId, ItemId, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecItemId.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecItemId[i].c_str(), &temp))
				{
					data.mItemId.push_back(temp);
				}
			}
		}
		{
			const char* ItemCount = element->Attribute("ItemCount");
			std::vector<std::string> vecItemCount;
			boost::split(vecItemCount, ItemCount, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecItemCount.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecItemCount[i].c_str(), &temp))
				{
					data.mItemCount.push_back(temp);
				}
			}
		}
		{
			const char* ExchangeItemId = element->Attribute("ExchangeItemId");
			std::vector<std::string> vecExchangeItemId;
			boost::split(vecExchangeItemId, ExchangeItemId, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecExchangeItemId.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecExchangeItemId[i].c_str(), &temp))
				{
					data.mExchangeItemId.push_back(temp);
				}
			}
		}
		{
			const char* ExchangeItemCount = element->Attribute("ExchangeItemCount");
			std::vector<std::string> vecExchangeItemCount;
			boost::split(vecExchangeItemCount, ExchangeItemCount, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecExchangeItemCount.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecExchangeItemCount[i].c_str(), &temp))
				{
					data.mExchangeItemCount.push_back(temp);
				}
			}
		}
		{
			const char* ExchangeItemWeight = element->Attribute("ExchangeItemWeight");
			std::vector<std::string> vecExchangeItemWeight;
			boost::split(vecExchangeItemWeight, ExchangeItemWeight, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecExchangeItemWeight.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecExchangeItemWeight[i].c_str(), &temp))
				{
					data.mExchangeItemWeight.push_back(temp);
				}
			}
		}
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("Fish_SeniorItemExchangeCFG Loaded. Load Data:%u", mMapData.size());
}

void Fish_SeniorItemExchangeCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/Fish_SeniorItemExchangeCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "Fish_SeniorItemExchangeCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		Fish_SeniorItemExchangeCFGData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readInt(L, "Type", data.mType);
		LuaCfgHelper::readVectorInt(L, "ItemId", data.mItemId);
		LuaCfgHelper::readVectorInt(L, "ItemCount", data.mItemCount);
		LuaCfgHelper::readVectorInt(L, "ExchangeItemId", data.mExchangeItemId);
		LuaCfgHelper::readVectorInt(L, "ExchangeItemCount", data.mExchangeItemCount);
		LuaCfgHelper::readVectorInt(L, "ExchangeItemWeight", data.mExchangeItemWeight);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("Fish_SeniorItemExchangeCFG Loaded. Load Data:%u", mMapData.size());
}

void Fish_SeniorItemExchangeCFG::Reload()
{
	mMapData.clear();
	Load();
}

Fish_SeniorItemExchangeCFG* Fish_SeniorItemExchangeCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Fish_SeniorItemExchangeCFG());
	}
	return msSingleton.get();
}

void Fish_SeniorItemExchangeCFG::Release()
{
	msSingleton.reset(nullptr);
}
